﻿// <copyright>
//   Copyright (c) Microsoft Corporation.  All rights reserved.
// </copyright>

/*
 *   DF changes
 *     inherits from DevForceDomainService<T>
 *     ObjectContext -> Manager
 *     Simplified CRUD methods, leveraging new methods in DevForceDomainService<T>
 */

namespace BigShelf
{
    using System.Linq;
    using System.ServiceModel.DomainServices.Hosting;
    using System.ServiceModel.DomainServices.Server;
    using BigShelf.Models;

    // Implements application logic using the BigShelfEntities Manager.
    // TODO: Add your application logic to these methods or in additional methods.
    // TODO: Wire up authentication (Windows/ASP.NET Forms) and uncomment the following to disable anonymous access
    // Also consider adding roles to restrict access as appropriate.
    [RequiresAuthentication]
    [EnableClientAccess]
    public partial class BigShelfService : DevForceDomainService<BigShelfEntities>
    //public partial class BigShelfService : LinqToEntitiesDomainService<BigShelfEntities>
    {

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the query method.
        public IQueryable<Book> GetBooks() { return Manager.Books; }
        public void InsertBook(Book entity) { InsertEntity(entity); }
        public void UpdateBook(Book entity) { UpdateEntity(entity); }
        public void DeleteBook(Book entity) { DeleteEntity(entity); }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the query method.
        public IQueryable<Category> GetCategories() { return Manager.Categories; }
        public void InsertCategory(Category entity) { InsertEntity(entity); }
        public void UpdateCategory(Category entity) { UpdateEntity(entity); }
        public void DeleteCategory(Category entity) { DeleteEntity(entity); }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the query method.
        public IQueryable<CategoryName> GetCategoryNames() { return Manager.CategoryNames; }
        public void InsertCategoryName(CategoryName entity) { InsertEntity(entity); }
        public void UpdateCategoryName(CategoryName entity) { UpdateEntity(entity); }
        public void DeleteCategoryName(CategoryName entity) { DeleteEntity(entity); }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the query method.
        public IQueryable<FlaggedBook> GetFlaggedBooks() { return Manager.FlaggedBooks; }
        public void InsertFlaggedBook(FlaggedBook entity) { InsertEntity(entity); }
        public void UpdateFlaggedBook(FlaggedBook entity) { UpdateEntity(entity); }
        public void DeleteFlaggedBook(FlaggedBook entity) { DeleteEntity(entity); }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the query method.
        public IQueryable<Friend> GetFriends() { return Manager.Friends; }
        public void InsertFriend(Friend entity) { InsertEntity(entity); }
        public void UpdateFriend(Friend entity) { UpdateEntity(entity); }
        public void DeleteFriend(Friend entity) { DeleteEntity(entity); }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the query method.
        public IQueryable<Profile> GetProfiles() { return Manager.Profiles; }
        public void InsertProfile(Profile entity) { InsertEntity(entity); }
        public void UpdateProfile(Profile entity) { UpdateEntity(entity); }
        public void DeleteProfile(Profile entity) { DeleteEntity(entity); }
    }
}